from phew import server, connect_to_wifi
from phew.template import render_template
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C
from time import sleep

import neopixel

# Web-Resourcen
files = 'mywebserver/'

# WLAN
# SSID = 'Attraktor'
# PW = 'blafablafa'


# # WLAN Connect
# ip_adresse = connect_to_wifi(SSID, PW)
# print(ip_adresse)


i2c = I2C(0, sda=Pin(20), scl=Pin(21))
oled = SSD1306_I2C(128, 64, i2c)

from wlantools import wlan

oled.fill(0)
oled.text(wlan.ifconfig()[0], 0, 0, 1)
oled.show()

sleep(1)


def page_template(page):
    return render_template(files + page)


@server.route("/control/led", ["GET"])
def led(request):
    state = request.query.get("state", None)
    led_pin = Pin(22, Pin.OUT)

    if state == 'toggle':
        led_pin.toggle()
    if state == 'on':
        led_pin.value(1)
    if state == 'off':
        led_pin.value(0)
    if state == 'blink':
        count = 5
        for x in range(0,count):
            led_pin.value(1)
            sleep(.5)
            led_pin.value(0)
            sleep(.5)
                
    # Zurück zum Controlcenter
    pt = page_template('redirect.pt')
    return pt

@server.route("/control/ws2812", ["GET"])
def ws2812(request):
    led   = request.query.get("led",   None)
    red   = request.query.get("red",   None)
    green = request.query.get("green", None)
    blue  = request.query.get("blue",  None)
    
    pin = machine.Pin(28)
    np = neopixel.NeoPixel(pin,5)

    if led == 'all':
        for led in range(0,5):
            np[led] = (int(red),int(green),int(blue))
    else:
        np[int(led)] = (int(red),int(green),int(blue))
        
    np.write()
                  
    # Zurück zum Controlcenter
    pt = page_template('redirect.pt')
    return pt

@server.route("/control/ssd1306", ["GET"])
def ssd1306(request):
    text1  = request.query.get("text1",  "")
    text2  = request.query.get("text2",  "")
    text3  = request.query.get("text3",  "")
    
    oled.fill_rect(0, 12, 127, 63, 0)
    oled.text(text1, 0, 12, 1)
    oled.text(text2, 0, 24, 1)
    oled.text(text3, 0, 36, 1)
    oled.show()
    pt = page_template('redirect.pt')
    return pt
  

css = True

def css_test():
    if css:
        return render_template("mywebserver/style.pt")
    
@server.route("/control/css", methods=["GET"])
def ctrl_css(request):
    state = request.query.get("state", None)
    global css
    if state == 'on':
        css = True
    else:
        css = False
    pt = page_template('control.pt')
    return pt

@server.route("/controlcenter", methods=["GET"])
def control(request):
    pt = page_template('control.pt')
#     pt = page_template('control_test_001.pt')
    return pt
    
# Wenn es die Seite nicht gibt -> Umleitung zum Controlcenter
@server.catchall()
def catch_all(request):
    pt = page_template('redirect.pt')
    return pt


server.run()