# webserver_001.py
#
# V.0.0.1
# 06.12.2023
# Peter Stöck
#
# Diese Version spielt.


import network


# Wlan Verbindung herstellen

wlan = network.WLAN(network.STA_IF)
wlan.active(True)
if not wlan.isconnected():
    print('connecting to network...')
    wlan.connect('Attraktor', 'blafablafa')
    while not wlan.isconnected():
        pass
print('network config:', wlan.ifconfig())


# Website erstellen

from phew.template import render_template
from os import stat
HTDOCS = 'htdocs/'

from phew import server

@server.route("/random", methods=["GET"])
def random_number(request):
  import random
  min = int(request.query.get("min", 0))
  max = int(request.query.get("max", 100))
  return str(random.randint(min, max))

@server.route("/info", methods=["GET"])
def info_site(request):
    return '''<h1>Infoseite vom Raspberry Pi Pico W</h1><br>
            /info<br>/test<br>/random'''

@server.route("/test", methods=["GET"])
def test_site(request):
    return render_template(HTDOCS + "html-test_001.html")
#     return render_template("html-test_001.html")
#     return '''
#               <h1>Überschrift</h1>
#               Dieses ist eine kleine HTML-Testseite.
#               <br>
#               Noch ist es nur ein einfacher Test!
#            '''   
#     return render_template("html-test_001.html")


@server.catchall()
def catch_all(request):
    return "<h1>Hallo, diese Webseite gibt es nicht!</h1>", 404
#     return render_template(HTDOCS + index.html)

server.run()
